/**************************************************************************//**
 * @item     CosyOS-II Kernel
 * @file     os_main.c
 * @brief    主函数
 * @author   迟凯峰
 * @version  V3.1.0
 * @date     2024.11.11
 ******************************************************************************/

#include "os_link.h"

/**
 \brief      主函数
 \param      无
 \return     无
 \note       CosyOS 的主函数是系统托管的，如非必要不建议用户擅自调整及修改。
             可在 init_hook 中进行前期的初始化工作，而后在 start_hook 中
             启动用户任务。
 */
int main(void)
{
	void s_init_timing(void);
	#if SYSCFG_SAFERUNTIME == __ENABLED__
	s_tid_t i;
	for(i = 0; i < OS_TASKTOTAL + 1; i++){
		s_sign_timeout[i] = 0;
	}
	#endif
	#if OS_TIMINTTOTAL || OS_TIMQRYTOTAL
	s_init_timing();
	#endif
	init_hook();
	mSys_INIT;
	uStartTask(Starter, OS_STATUS_READY);
	uStartTask(Sysidle, OS_STATUS_READY);
	while(true);
}
