/**************************************************************************//**
 * @item     CosyOS-II Kernel
 * @file     os_starter.c
 * @brief    启动任务（Starter）
 * @author   迟凯峰
 * @version  V3.1.0
 * @date     2024.11.11
 ******************************************************************************/

#include "os_link.h"

sCat2Str
(
	SYSCFG_STARTERCREATE,
	CreateTask(Starter, SYSCFG_TASKPRIORITY - 2, MCUCFG_STACKSIZE_STARTER, 0, 0)
)
{
	#if OS_TIMINTTOTAL || OS_TIMQRYTOTAL
	s_u8_t i;
	#if OS_TIMQRYTOTAL
	i = OS_TIMQRYTOTAL;
	while(i--){
		if(s_timqry_handle[i]->hookortask){
			sStartTask_TimQry(i);
		}
	}
	#endif
	#if OS_TIMINTTOTAL
	i = OS_TIMINTTOTAL;
	while(i--){
		if(s_timint_handle[i]->hookortask){
			sStartTask_TimInt(i);
		}
	}
	#endif
	#endif
	start_hook();
	uDeleteTasking;
	uEndTasking;
}
